diff -ru Math-Pari-2.01080603\Pari.xs Math-Pari-2.01080603.patched\Pari.xs
--- Math-Pari-2.01080603\Pari.xs	Fri Dec 11 03:18:24 2009
+++ Math-Pari-2.01080603.patched\Pari.xs	Wed Mar 03 09:21:26 2010
@@ -1,3 +1,9 @@
+/* we need to include windows.h quite early to avoid some macro name collisions */
+#ifdef _WIN32
+#  define WIN32_LEAN_AND_MEAN
+#  include <windows.h>
+#endif
+
 #  include <pari.h>
 #  include <graph/rect.h>
 #  include <language/anal.h>
diff -ru Math-Pari-2.01080603\patches\diff_2.1.7_mingw-w64 Math-Pari-2.01080603.patched\patches\diff_2.1.7_mingw-w64
--- Math-Pari-2.01080603\patches\diff_2.1.7_mingw-w64	Wed Mar 03 09:35:45 2010
+++ Math-Pari-2.01080603.patched\patches\diff_2.1.7_mingw-w64	Wed Mar 03 09:26:18 2010
@@ -0,0 +1,17 @@
+diff -ru pari-2.1.7.orig\src\gp\highlvl.c pari-2.1.7\src\gp\highlvl.c
+--- pari-2.1.7.orig\src\gp\highlvl.c Tue Apr 23 17:29:37 2002
++++ pari-2.1.7\src\gp\highlvl.c Wed Mar 03 09:21:11 2010
+@@ -18,6 +18,13 @@
+ /*        SOME GP FUNCTION THAT MAY BE USEFUL OUTSIDE OF IT        */
+ /*                                                                 */
+ /*******************************************************************/
++
++/* we need to include windows.h quite early to avoid some macro name collisions */
++#ifdef _WIN32
++#  define WIN32_LEAN_AND_MEAN
++#  include <windows.h>
++#endif
++
+ #include "pari.h"
+ #ifdef macintosh
+ #  include "rect.h"
diff -ru Math-Pari-2.01080603\utils\Math\PariBuild.pm Math-Pari-2.01080603.patched\utils\Math\PariBuild.pm
--- Math-Pari-2.01080603\utils\Math\PariBuild.pm	Fri Dec 11 02:45:28 2009
+++ Math-Pari-2.01080603.patched\utils\Math\PariBuild.pm	Tue Mar 02 23:02:12 2010
@@ -481,6 +481,7 @@
 			      'patches/diff_2.1.6_no-common'],
 		 '2.1.7' =>  [
 			($^O =~ /darwin/i ? 'patches/diff_2.1.6_no-common' : ()),
+			($^O eq 'MSWin32' ? 'patches/diff_2.1.7_mingw-w64' : ()),
 			      'patches/patch-pari-unnormalized-float',
 			      'patches/diff_2.1.7_-O',
 			      'patches/diff_2.1.7_div',
@@ -507,7 +508,7 @@
   return '/' unless $^O =~ /win32/i;
   my($patch, $p) = (shift, 'utils/inc_h.diff');
   $p =~ s,/,\\,g;
-  system "$patch --binary < $p"
+  system "$patch -p0 --binary < $p"
     or warn("... Apparently, your patch takes flag --binary...\n"),
        return ('\\', '--binary');
   return '\\';
@@ -887,6 +888,8 @@
 	   or $os eq 'freebsd' or $os =~ /^cygwin/) {
     chomp($machine = `uname -m`);
     $machine ||= 'ix86';
+  } elsif (($Config{archname} eq 'MSWin32-x86-multi-thread') && ($Config{cc} =~ /gcc/)) {
+    $machine = 'ix86';
   } elsif (0 and $os =~ /win32/i and not $Config{gccversion}) {
     # Not needed with rename of kernel1.s to kernel1.c?
     $machine = 'port'; # Win32 compilers would not understand the assmebler anyway
